# -*- Mode: Python -*-
# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4

class InterfaceInstaller:

    def __init__(self):
        """
        This function takes no arguments, and solely prepares the installer
        ui to be used and queried (load cache) 
        """

    def is_installed(self, package, data=None):
        """
        Check whether a package is installed or not.
        """

    def install(self, package, data):
        """
        Actual package installation.
        """

from threading import Thread
from codeina.extern.log import log

class InstallerThread (Thread):

    def __init__ (self, installer, provider, done_cb, package):
        Thread.__init__ (self)
        self.installer = installer
        self.provider = provider
        self.done_cb = done_cb
        self.installed_packages = []
        self.package = package

    def run (self):
        log.log('installer', 'starting the installer thread')
        if not self.package is None:
            result = self.installer.install(self.package)
            if len(result) == 0:
                self.installed_packages.append(self.package)
        else:
            if 'install_list' in dir (self.installer):
                log.log ('installer', 'installing all products in one time')
                self.installer.install_list (self.provider.products)
            else:
                log.log ('installer', 'installing all products one by one')
                for pkg in self.provider.products:
                    result = self.installer.install (pkg)
                    try:
                        if len(result) == 0:
                            self.installed_packages.append(pkg)
                            # TODO test if required plugin has been installed
                    except:
                        log.log('installer', 'problem in adding installed package to list')

        # FIXME return with an other value if the install failes
        log.debug ('installer', 'installation done')
        self.done_cb (0)

    def getInstalledPackages(self):
        return self.installed_packages
