# -*- Mode: Python -*-
# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4

from codeina.installer import InterfaceInstaller
from codeina.extern.log import log
from gettext import gettext as _
import os
import tempfile

class Installer(InterfaceInstaller):

    def __init__ (self):
        import popen2
        fin, fout = popen2.popen2("dpkg -l | awk '{ print $2}'")
        self.installed_packages = fin.readlines ()

    def is_installed(self, package, data=None):
        return package in [p.strip () for p in self.installed_packages]

    def _create_selections_file (self, list):
        f = tempfile.NamedTemporaryFile ()
        for pkg in list:
            log.log ('installer', 'selections-file write: %s\tinstall\n' % pkg)
            f.write ('%s\tinstall\n' % pkg)
        f.flush ()
        return f

    def _launch_synaptic (self, list):
        f = self._create_selections_file (list)
        """
        Not working ??? A bug in synaptic ?
        command = ["gksu", "--", "/usr/sbin/synaptic", "--update-at-startup", "--hide-main-window",
                    "--non-interactive", "--finish-str", _('"Missing codecs installed"'),
                    "--set-selections-file", f.name]
        """
        command = ["gksu", "--", "/usr/sbin/synaptic", "--hide-main-window",
                    "--non-interactive", "--finish-str", _('"Missing codecs installed"'),
                    "--set-selections-file", f.name]
        log.log ('installer', 'running command: %s' % ' '.join (command))
        import subprocess
        subprocess.call (['gksu', '--', 'apt-get', 'update'])
        result = subprocess.call (command)
        f.close ()
        if result == 0:
            return []
        else:
            return list

    def install(self,package,data):
        self._launch_synaptic ([package])

    def install_list (self, list):
        self._launch_synaptic (list)
