# -*- Mode: Python -*-
# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4

from codeina.installer import InterfaceInstaller
from codeina.extern.log import log
from codeina.productlist import Product
import os
import subprocess

class Installer(InterfaceInstaller):

    def __init__ (self):
        p = subprocess.Popen(["rpm","-qa", "--queryformat", "%{NAME}\n"], close_fds=True, stdout=subprocess.PIPE)
        output = p.communicate()[0]
        self.installed_packages = [p.strip() for p in output.split("\n")][:-1]

    def is_installed(self, package, data=None):
        if (not isinstance(package, Product)) and os.path.isfile(package):
             p = subprocess.Popen(["rpm", "-q", "--queryformat","\"%{NAME}\\n\"" "-p", package], close_fds=True, stdout=subprocess.PIPE)
             output = p.communicate()[0]
             package_name = output.readlines()[0].strip()
        else:
            package_name = package.nick
        return package_name in self.installed_packages

    def install(self,package,data=None):
        log.debug('installer', 'trying to install %s' % package.nick)
        if (not isinstance(package, Product)) and os.path.isfile(package):
            package_name = package 
        else:
            package_name = package.nick
        from codeina import check
        distro_name = check.get_distro_name()
        if 'mandriva' in distro_name:
            result = os.system('gurpmi --auto %s' % package_name)
        elif 'fedora' in distro_name:
            result = os.system('system-install-package %s' % package_name)
        else:
            result = os.system('urpmi --auto %s' % package_name)
        if result == 0:
            return []
        else:
            return [package]
