# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4

import gtk
from gettext import gettext as _

class ChoosePackageDialog (gtk.Dialog):

    def __init__ (self, provider):
        self.dialog_title = 'Package Installer'
        self.msg = "<b>"
        self.msg += _("Choose package from \"%s\":") % provider.id
        self.msg += "</b>\n"
        gtk.Dialog.__init__ (self, None, None, 0, None)
        self.set_title (self.dialog_title)

        stock = gtk.image_new_from_stock (gtk.STOCK_DIALOG_INFO,
                                          gtk.ICON_SIZE_DIALOG)
        lbl = gtk.Label ()
        lbl.set_text ("<big>"+self.msg+"</big>")
        lbl.set_use_markup (True)

        hbox = gtk.HBox ()
        hbox.set_border_width (8)
        hbox.set_spacing (8)

        hbox.pack_start (stock, False, False)
        hbox.pack_start (lbl, False, False)
        hbox.show()
        
        # Set the icon of this dialog
        from codeina import configure
        self.set_icon_from_file (configure.make_icon_path('codeina.png'))

        vbox = gtk.VBox()

        valign = gtk.Alignment(0, 1, 0, 0)
        vbox.pack_start(valign)

        vbox.pack_start (hbox, True, False)

        product_id = 0
        for product in provider.products:
	        halign = gtk.Alignment(1, 0, 1, 0)
            
            h = gtk.HBox()
            h.add(gtk.Label ("%s" % product.name))
            button = gtk.Button(_("_Install"))
            button.my_id = product_id
            button.connect('clicked', self.clicked)
            h.add(button)
            h.show()
            halign.add(h)
            vbox.pack_start(halign, False, False, 3)
            product_id = product_id + 1

        vbox.show()

        self.vbox.pack_start(vbox)
        self.vbox.show_all ()
        button = gtk.Button(stock=gtk.STOCK_CANCEL)
        self.add_action_widget(button, gtk.RESPONSE_CANCEL)
        self.show_all()

    def clicked(self, button):
        self.response(button.my_id)


