# -*- Mode: Python -*-
# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4

import gtk
from gettext import gettext as _

class CodeinaMessageDialog (gtk.MessageDialog):

    def __init__ (self, message, buttons, level):
        gtk.MessageDialog.__init__ (self, None, 0, level, buttons, message)
        from codeina import configure
        self.set_icon_from_file (configure.make_icon_path ('codeina.png'))
        self.set_markup (message)
        self.set_property("skip-taskbar-hint", False)

    def __call__ (self):
        try:
            self.set_title (self.dialog_title)
        except AttributeError:
            self.set_title (_('Codeina'))
        res = self.run ()
        self.hide ()
        return res

class CodeinaSimpleDialog (CodeinaMessageDialog):

    def __init__ (self, msg=None):
        if msg:
            CodeinaMessageDialog.__init__ (self, msg, gtk.BUTTONS_OK, gtk.MESSAGE_INFO)
        else:
            CodeinaMessageDialog.__init__ (self, self.msg, gtk.BUTTONS_OK, gtk.MESSAGE_INFO)


class CodeinaWarningDialog (CodeinaMessageDialog):

    def __init__ (self, msg=None):
        if msg:
            CodeinaMessageDialog.__init__ (self, msg, gtk.BUTTONS_OK, gtk.MESSAGE_WARNING)
        else:
            CodeinaMessageDialog.__init__ (self, self.msg, gtk.BUTTONS_OK, gtk.MESSAGE_WARNING)
